From f4094f2a579c045e6c4d993c64c32436a4327d08 Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 23/32] Issues: Add to stream hubs


---

diff --git a/hubs/widgets/issues/__init__.py b/hubs/widgets/issues/__init__.py
index 0388121..a41e56f 100644
--- a/hubs/widgets/issues/__init__.py
+++ b/hubs/widgets/issues/__init__.py
@@ -20,7 +20,7 @@ class Issues(Widget):
         )
     ]
     is_react = True
-    hub_types = ['user']
+    hub_types = ['user', 'stream']
     cached_functions_module = ".functions"
     views_module = ".views"
 
diff --git a/hubs/widgets/issues/functions.py b/hubs/widgets/issues/functions.py
index e483442..8b4d935 100644
--- a/hubs/widgets/issues/functions.py
+++ b/hubs/widgets/issues/functions.py
@@ -1,12 +1,19 @@
 import requests
 
+from hubs.models.hub import Hub
 from hubs.widgets.caching import CachedFunction
 
 
 class GetBugzillaBugs(CachedFunction):
 
     def execute(self):
-        email = self.instance.hub.config['bugzilla_email']
+        if self.instance.hub.hub_type == "stream":
+            user_hub = Hub.query.filter_by(name=self.instance.hub.name).first()
+            email = user_hub.config.get('bugzilla_email')
+        else:
+            email = self.instance.hub.config.get('bugzilla_email')
+        if email is None:
+            return [[], None]
         endpoint = 'https://bugzilla.redhat.com/jsonrpc.cgi?method=Bug.search&params=' \
                    '[{{' \
                    '"{}":"{}",' \
@@ -31,7 +38,11 @@ class GetBugzillaBugs(CachedFunction):
         return [res, total_count]
 
     def should_invalidate(self, message):
-        email = self.instance.hub.config['bugzilla_email']
+        if self.instance.hub.hub_type == "stream":
+            user_hub = Hub.query.filter_by(name=self.instance.hub.name).first()
+            email = user_hub.config.get('bugzilla_email')
+        else:
+            email = self.instance.hub.config.get('bugzilla_email')
         mode = self.instance.config['mode']
         if message['topic'].endswith('bugzilla.bug.new') or \
            message['topic'].endswith('bugzilla.bug.update'):
@@ -46,7 +57,13 @@ class GetBugzillaBugs(CachedFunction):
 class GetPagureIssues(CachedFunction):
 
     def execute(self):
-        username = self.instance.hub.config['pagure_username']
+        if self.instance.hub.hub_type == "stream":
+            user_hub = Hub.query.filter_by(name=self.instance.hub.name).first()
+            username = user_hub.config.get('pagure_username')
+        else:
+            username = self.instance.hub.config.get('pagure_username')
+        if username is None:
+            return [[], None]
         endpoint = "https://pagure.io/api/0/user/{}/issues?author={}"
         author = self.instance.config['mode'] == 'author'
         response = requests.get(endpoint.format(username, author)).json()
@@ -68,7 +85,11 @@ class GetPagureIssues(CachedFunction):
 
     def should_invalidate(self, message):
         mode = self.instance.config['mode']
-        username = self.instance.hub.config['pagure_username']
+        if self.instance.hub.hub_type == "stream":
+            user_hub = Hub.query.filter_by(name=self.instance.hub.name).first()
+            username = user_hub.config.get('pagure_username')
+        else:
+            username = self.instance.hub.config.get('pagure_username')
         if message['topic'].endswith('pagure.issue.new') or \
            message['topic'].endswith('pagure.issue.edit') or \
            message['topic'].endswith('pagure.issue.assigned.added') or \
@@ -86,7 +107,13 @@ class GetPagureIssues(CachedFunction):
 class GetGithubIssues(CachedFunction):
 
     def execute(self):
-        username = self.instance.hub.config["github_username"]
+        if self.instance.hub.hub_type == "stream":
+            user_hub = Hub.query.filter_by(name=self.instance.hub.name).first()
+            username = user_hub.config.get('github_username')
+        else:
+            username = self.instance.hub.config.get('github_username')
+        if username is None:
+            return [[], None]
         endpoint = "https://api.github.com/search/issues?q=type:issue+{}:{}+state:open&sort:updated"
         mode = "author" if self.instance.config['mode'] == 'author' else "assignee"
         response = requests.get(endpoint.format(mode, username)).json()
@@ -107,7 +134,11 @@ class GetGithubIssues(CachedFunction):
 
     def should_invalidate(self, message):
         mode = self.instance.config['mode']
-        username = self.instance.hub.config['github_username']
+        if self.instance.hub.hub_type == "stream":
+            user_hub = Hub.query.filter_by(name=self.instance.hub.name).first()
+            username = user_hub.config.get('github_username')
+        else:
+            username = self.instance.hub.config.get('github_username')
         if message['topic'].endswith('github.issue.opened') or \
            message['topic'].endswith('github.issue.reopened') or \
            message['topic'].endswith('github.issue.edited') or \
diff --git a/hubs/widgets/issues/views.py b/hubs/widgets/issues/views.py
index e6d1e48..f4ddc72 100644
--- a/hubs/widgets/issues/views.py
+++ b/hubs/widgets/issues/views.py
@@ -12,22 +12,25 @@ class DataView(WidgetView):
 
     def get_context(self, instance, *args, **kwargs):
 
-        if not (instance.hub.config['bugzilla_email'] or instance.hub.config['github_username'] or
-                instance.hub.config['pagure_username']):
+        if instance.hub.hub_type == "stream":
+            user_hub = Hub.query.filter_by(name=instance.hub.name).first()
+            bugzilla_email = user_hub.config.get('bugzilla_email')
+            github_username = user_hub.config.get('github_username')
+            pagure_username = user_hub.config.get('pagure_username')
+        else:
+            bugzilla_email = instance.hub.config.get('bugzilla_email')
+            github_username = instance.hub.config.get('github_username')
+            pagure_username = instance.hub.config.get('pagure_username')
+
+        if not (bugzilla_email or github_username or pagure_username):
             return dict(
                 status="ERROR",
                 message="You must configure VCS details in the hub configuration in order to use this widget."
             )
 
-        bugzilla = pagure = github = []
-        bzcnt = pcnt = ghcnt = None
-
-        if instance.hub.config['bugzilla_email']:
-            [bugzilla, bzcnt] = GetBugzillaBugs(instance)()
-        if instance.hub.config['pagure_username']:
-            [pagure, pcnt] = GetPagureIssues(instance)()
-        if instance.hub.config['github_username']:
-            [github, ghcnt] = GetGithubIssues(instance)()
+        [bugzilla, bzcnt] = GetBugzillaBugs(instance)()
+        [pagure, pcnt] = GetPagureIssues(instance)()
+        [github, ghcnt] = GetGithubIssues(instance)()
 
         all_issues = bugzilla + pagure + github
         all_issues.sort(key=lambda x: arrow.get(x['updated_at']), reverse=True)
@@ -43,14 +46,14 @@ class DataView(WidgetView):
                 'bugzilla': {'count': bzcnt,
                              'link': 'https://bugzilla.redhat.com/buglist.cgi?quicksearch={}:{}'
                                  .format('reporter' if instance.config['mode'] == 'author' else 'assigned_to',
-                                         instance.hub.config['bugzilla_email'])
+                                         bugzilla_email)
                              }
             })
 
         if pcnt is not None:
             data['counts'].update({
                 'pagure': {'count': pcnt,
-                           'link': 'https://pagure.io/user/{}/issues'.format(instance.hub.config['pagure_username'])
+                           'link': 'https://pagure.io/user/{}/issues'.format(pagure_username)
                            }
             })
 
@@ -58,7 +61,7 @@ class DataView(WidgetView):
             data['counts'].update({
                 'github': {'count': ghcnt,
                            'link': 'https://github.com/issues?q=type:issue+state:open+{}:{}'
-                               .format(instance.config['mode'], instance.hub.config['github_username'])
+                               .format(instance.config['mode'], github_username)
                            }
             })
 

